DAT objectName byte "RobotHeader131108a", 0
CON
{ Private Notes
  120417 change baud for remote and touchscreen
  to 57,600.

}
 ' EEPROM Use
{


  $FF00  |                   |                   |                   |                   |
  $FF10  |                   |                   |                   |                   |
  $FF20  |                   |                   |                   |                   |
  $FF30  |                   |                   |                   |                   |
  $FF40  |                   |                   |                   |                   |
  $FF50  |                   |                   |                   |                   |
  $FF60  |                   |                   |                   |                   |
  $FF70  |                   |                   |                   |                   |
  $FF80  |                   |                   |                   |                   |
  $FF90  |                   |                   |                   |                   |
  $FF00  |                   |                   |                   |                   |
  $FFA0  |                   |                   |                   |                   |
  $FFC0  |        6          |        6          |        5          |        5          |
  $FFD0  |        4          |        4          |        3          |        3          |
  $FFE0  | Unit #2 firmware  |subV2, code2, X, X | Unit #1 firmware  |subV1, code1, X, X |
  $FFF0  | FIRMWAREVersion  |FIRMWARESubVersion|                   |     Unit ID       |
  
  The basestation will have the firmware version of each other unit in it's EEPROM.
  Unit #N's fw location = FIRMWARELocation - (N * FIRMWAREDiscriptionSize)

  Each Propeller with an permanently attached EEPROM (with 64K or more space)
  should have a unique ID.

  ID numbers 1 through 7 are QuickStart boards
  A label with the Propeller's ID number should be attached to the board when the ID
  number is assigned.
  
  Some Propeller IDs

  
}
  FIRMWARE_DISCRIPTION_SIZE = 8 ' 4 for date, 1 for subV letter, 3 for other codes
                               ' codes include fw update started or successfully finished
  FIRMWARE_VERION = 110808  ' 4 bytes
  FIRMWARE_SUB_VERION = "8"  ' 1 byte, for now the following three bytes
  FIRMWARE_LOCATION = $FFF0
  FIRMWARE_SUB_LOCATION = FIRMWARE_LOCATION + 4 ' three last bytes aren't used yet
  ID_EEPROM_LOCATION = $FFFC 'FIRMWARE_LOCATION + 12 ' 4 bytes
  ' Unique to each Propeller
  
  SYSTEM_ID_EEPROM_LOCATION = $FFF8 'FIRMWARE_LOCATION + 12 ' 4 bytes
  ' Used in multi Propeller systems.
  
  FIRST_PROTECTED_EEPROM = FIRMWARE_LOCATION
  END_OF_PROTECTED_EEPROM = FIRMWARE_LOCATION + 16
  FIRMWARE_SCRATCH_PAD_LOCATION = $8000 ' use for wireless firmware updates

  
  ' EEPROM firmware update codes
  #0, NO_INFO_YET_FW, UPDATE_STARTED_FW, UPDATE_COMPLETE_FW ' Firmware updates will first be copied
                                                      ' to uppper EEPROM then from upper EEPROM
                                                      ' to lower EEPROM.       
CON    '' Color enumeration added 120101 
  #0, BLACK, EASTER_EGG, BLUE_1, BLUE_2, BLUE, GREEN_1, BLUE_GREEN_1, GREENISH_1_BLUE_2, { 0-7
    } GREENISH_1_BLUE, GREEN_2, BLUEISH_1_GREEN_2, GREENISH_2_BLUE_2, GREENISH_2_BLUE, { 8-12
    } GREEN, BLUEISH_1_GREEN, BLUEISH_2_GREEN, WHITE, RED, YELLOW, PURPLE, CYAN, F_RED, {
    } F_GREEN, YELLOW_ORANGE, ORANGE, FIRST_TEMP_COLOR
  
  '' Parameter enumeration
  #0, P_COLUMN, P_ROW, P_COLOR_TEXT, P_COLOR_BACKGROUND, P_ACTION_HIGH, P_ACTION_LOW, {
    } P_STRING
  
  '' Menu Actions
  #0, _NoAction, _SetTimer, _SetAlarm, _LightSingle, _LightGroup, _MainDutyChange, _PerimeterDutyChange, { 0-6
    } _LedBack, _LedForward, _OneUpMenu, _ChannelUp, _ChannelDown, _VolumeUp, _VolumeDown, _BoxPower, {  7-14
    } _VcrPower, _TvPower, _SetTarget, _OvenTime, MENU_S_EDIT, MENU_S_VIEW, _ActiveHour, _ActiveMinute, {  15-22
    } _ActiveSecond, _ActiveYear, _ActiveMonth, _ActiveDate, _ActiveDayOfWeek, _LineOn1, _LineOn2, { 23-29
    } _LineOn3, _LineOn4, _LineOn5, _NunchuckOff, _ToggleSdAction { 30-34 }
       
CON
  ' RobotComAlpha03 add 8-bit data bus and TouchscreenSlave info
  ' 03 Big change 

  ' 8-bit single Prop to single Prop message enumeration 
  '#1, _NewToScreen, _OldToScreen, _TouchFromScreen

  ' 8-bit bus message enumeration 
  #1, _MasterSync, _RequestSync, _BusMessage, _NewMenu{clear screen}, _DisplayText, _PlotPixels,{not used yet
    } _TouchFromScreen, _ChangeTouchscreenMode, _Reboot, _Sleep
  
  
  ' offsets, 8-bit bus only two Props, master and slave combo. 
  '_TxType8Bit = 0  ' one of 8-bit bus messages
  _LineXOffset8BitPr = 0
  _LineYOffset8BitPr = 1
  _TextColorOffset8BitPr = 2
  _BackgroundColorOffset8BitPr = 3
  _TextOffset8BitPr = 4


  ' PlayStation2 Remote Constants
  _Cs8BitPrPin = 15
  _Clock8BitPrPin = 14

  _PrMaxSystemId = 1
  
  ' control character enumeration
  #0, _Null, _StartOfHeader, _StartText
  CARRIAGE_RETURN = 13
  _GroupSeparator = 29
  COM_ATTENTION = $7E
  _PropToPropPinOffset = 14          
  PROP_TO_PROP_REMOTE_BAUD = 115_200
  DEBUG_REMOTE_BAUD = PROP_TO_PROP_REMOTE_BAUD
                         
  ' com type enumeration
  #1, DIRECT_SINGLE_PACKET_WIRELESS, _HoppingSinglePacketWireless, {
    } _DirectAsciiWireless, _HoppingAsciiWireless, {
    } _DirectSinglePacket, _HoppingSinglePacket, _DirectAscii, {
    } _HoppingAscii, _EightBit {Probably not needed since an 8-bit line
    will know it's an 8-bit line.} 
  ' both _DirectAsciiWireless, _HoppingAsciiWireless messages
  ' should only transmit a byte with the value of 13 as an end of message
  ' character.  Data should be sent as ASCII hexidecimal to avoid sending
  ' a 13 other than at the end of a message.
  ' I use a serial driver that watches for an end of message character so
  ' I don't want the end of message character showing up other than at the
  ' end of a message.  These two com types are likely used with XBee modules.

  ' I have yet to come up with a "hopping" protocol.
  
  ' targets (for now I think I have fewer than 254)
  ' robot targets
  _Broadcast = 255
  #1, _Reserved1, _Scribbler2, _Roomba, _Roboni, _Roboni2, _Omni, _Rover5, { 1 - 6
    } _Treaded, _Arm, _TRex600, _QuadCopterLarge, _QuadCopterSmall ' 7 - 11
  ' controller targets  
  #20, _UniverseRemoteInput, _UniverseRemoteGraphics, PS2_TOUCHSCREEN_REMOTE_INPUT, { 20 - 22
    }  _Ps2TouchscreenRemoteGraphics, _RcAssist, _WiiCameraGuidance ' 23 - 25
  ' lab targets   
  #40, _LabA, _LabB, _LabC, _LabD, _LabE, _LabF, _LabG, _LabH ' 40 - 47
  ' QuickStart targets
  #59, _GenericQuickStart, _QuickStart00, _QuickStart01, _QuickStart02, { 59 - 62
    } _QuickStart03, _QuickStart04, _QuickStart05, _QuickStart06, { 63 - 66
    } _QuickStart07, _QuickStart08, _QuickStart09, _QuickStart10, { 67 - 70
    } _QuickStart11 ' 71
  ' FOB targets
  #79, _GenericFob, _Fob0, _Fob1, _Fob2, _Fob3, _Fob4, _Fob5, _Fob6, _Fob7, { 79 - 87
    } _Fob8, _Fob9, _ModifiedFob ' 88 - 90

  ' transmitter type
  #1, _NordicOld, _NordicNew, _NordicFob, _Spektrum, _Rc, _XBeeZb, XBeeZbPro, { 1 - 7
    } _XBeeXsc ' 8
    
  ' transmission type
  #1, _ControllerStream, _DataOutNoReply, _DataExpectReply, _Command, _Enquire, _Acknowledgment

  ' _Command enumeration (should be preceded by "_Command")
  #0, _StopCmd, _PlayStation2Cmd, _WiiNunchuckCmd, _ButtonKnobAndKeyCmd, {
    } _ButtonKnobKeyAndNunchuckCmd, _QsPadsCmd, _QsTerminalCmd, _FobCmd, _FobModifiedCmd 
  {
  ' _Command types
  _DirectionVectorFloat = _ButtonKnobAndKey
  _AdjustPid = _Button
  _PidData = _ButtonAndKnob ' followed by three PID parameters coded in ASCII Hex.
  _DisplayMessage = _LedSingle ' followed by the single byte message code
  _DisplayLedText = _LedGroup ' followed by text to display
  _ChangeLedSettings = _StopTxNunchuckToRoboni0 ' followed by single byte setting code

  ' LED settings enumeration (after  _Command, _ChangeLedSettings)
  #0, _DelayUp, _DelayDown, _BrightnessUp, _BrightnessDown

  ' LED messages enumeration (after  _Command, _DisplayMessage)
  #0, _LedMessageR1, _LedMessageL1, _LedMessageR2, _LedMessageL2, { 0 - 3
    } _LedMessageP, _LedMessagePUp, _LedMessagePDown, { 4 - 6
    } _LedMessageI, _LedMessageIUp, _LedMessageIDown, { 7 - 9
    } _LedMessageD, _LedMessageDUp, _LedMessageDDown, { 10 - 12
    } _LedMessageCR, _LedMessageAllFont, _LedMessagePattern

    }
  ' controller enumeration (should be preceded by "_ControllerStream")
  #0, _NoController, _PlayStation2, _WiiNunchuck, _UniButtonKnobAndKey, {
    } _UniButtonKnobKeyAndNunchuck, _QsPads, _QsTerminal, _Fob, _FobModified 

  ' Scribbler2 _DataOut data types probably send eight words per packet
  #0, FILE_NAME_DATA, _Result1Data, _Result2Data, _Result3Data, _MotionData

  ' Vex Mecanum _DataOut data types
  _AngleMecanum = _Result1Data
  _MagnitudeMecanum = _Result2Data
  _RotationMecanum = _Result3Data
  _MotionMecanum = _MotionData
  
  ' offsets
  _TargetOffset = 1
  _AttachedOffset = 2
  _MessageCountOffset = 3
  _TransmissionTypeOffset = 4
  _TransmissionSubTypeOffset = 5
  
  ' _DefaultData from _Scribbler2 offsets
  _BatteryS2 = 7 ' one byte, two hexadecimal characters.
  _LeftSpeedS2 = 9 ' two bytes, four hexadecimal characters.
                 ' instead of -256 to 256, use 0 to 511, (add and subtract 255, which loses -256)
  _RightSpeedS2 = 17 ' two bytes, four hexadecimal characters.

  ' _FileNameData from _Scribbler2 offset
  _FileNameS2 = 7

  ' _LightSensorData from _Scribbler2 offset
  _LeftLightSensorS2 = 7 ' one byte, two hexadecimal characters.
  _MiddleLightSensorS2 = 9
  _RightLightSensorS2 = 11
  _LeftObstacleSensorS2 = 13 ' one bit, one ASCII binary character.
  _RightObstacleSensorS2 = 14
  _LeftLineSensorS2 = 15 ' one bit, one ASCII binary character.
  _RightLineSensorS2 = 16

  ' _QsPads offset
  _Pad0Qs = _TransmissionSubTypeOffset + 1 ' one byte, two hexadecimal characters.
  
  ' QuickStart pads as remote enumeration
  #0, _StarRevHard, _StarRev, _StarForward, _StartForwardHard, {
    } _PortForwardHard, _PortForward, _PortRev, _PortRevHard
     
  S2_BAUD = 115_200
  PR_BAUD = 115_200
  LARGEST_NORDIC_PAYLOAD_SIZE = 32
  DEFAULT_ROBOT_NORDIC_PAYLOAD = 24
  S2_NORDIC_PAYLOAD_SIZE = 24
  LARGE_BUFFER_SIZE = 512
  LARGEST_STRUCTURE_SIZE = 32
     
  ' PlayStation 2 Remote (Prd)data type enumeration
  #0, DATE_PRD, TIME_PRD, STATUS_PRD, SPEED_PRD, COURSE_PRD, BATTERY_PRD, { 0 - 5
    } X_TOUCH_PRD, Y_TOUCH_PRD, SD_TOGGLE_PRD, OTHER_MESSAGE_PRD, { 6 - 9
    } SD_USE_GRANTED_PRD, SD_DENIED_PRD ' 10 - 11
  SKIP_13_EOL_PRD = 13
  #14, LAST_PRD
      
  ' _Enquire types (after transmission type), Also use in CheckStylusDown method as modes
  #0, BUTTON_ONLY, BUTTON_AND_KNOB, BUTTON_KNOB_AND_KEY, BUTTON_KNOB_KEY_AND_NUNCHUCK ' 0 - 3
      
  ' PlayStation 2 Remote (Pr) constants
  _LargestParameterSentExtraPr = 11 
  _LargestParameterSentNormalPr = 9
  _LargestDynamicParameter = _LargestParameterSentExtraPr
  _DataSizeSmallPr = 3
  DATA_SIZE_DATE_PR = 11
  DATA_SIZE_MODE_PR = 24
  _DataSizeTouchXyPr = 3       ' includes room for terminating zero 
  _DataSizeSdStatePr = 14
              
  DEBUG_TX_PIN = 30 
  DEBUG_RX_PIN = 31

  ' debug state enumeration
  #0, NO_DEBUG, YES_DEBUG 
              {
  '' Mode enumeration
  #0, _CenteredMode, _LeftAligned, _RightAligned
   }
  CHANGABLE_PARAMETER_FLAG = "\"  ' followed by GPS data type, followed by format info.
  FRAME_CHANGABLE_PARAMETER = "/"
  
   ' changable parameter format enumeration
  #0, LEFT_JUSTIFY_FORMAT, _CenterFormat, _RightJustifyFormat, _LeftWithOneSpaceFormat, _RightWithOneSpaceFormat
  
  ' box type enumeration
  #0, _FocusBox, _NormalBox

  ' PlayStation 2 button enumeration
  #0, SQUARE_PS2, CROSS_PS2, CIRCLE_PS2, TRIANGLE_PS2, { 0 - 3
    } R1_PS2, L1_PS2, R2_PS2, L2_PS2, { 4 - 7
    } LEFT_ARROW_PS2, DOWN_ARROW_PS2, RIGHT_ARROW_PS2, UP_ARROW_PS2, { 8 - 11
    } START_PS2, RIGHT_JOYSTICK_PS2, LEFT_JOYSTICK_PS2, SELECT_PS2' 12 - 15
 
CON

  MAX_BUTTONS_PER_MENU = 64
  PRE_TEXT_BYTES = 7         
  NON_TEXT_BYTES = PRE_TEXT_BYTES + 1 ' includes terminating zero
  MAX_TEXT_BYTES = COLUMNS
  'MAX_BYTES_PER_MENU = MAX_BUTTONS_PER_MENU * (NON_TEXT_BYTES + MAX_TEXT_BYTES) '2,432
  MAX_BYTES_PER_MENU = (MAX_BUTTONS_PER_MENU * NON_TEXT_BYTES) + SCREEN_SIZE ' 1,022
  MENU_BUFFER_SIZE = MAX_BYTES_PER_MENU + (MAX_BUTTONS_PER_MENU * 2)  ' 2,432 + 128 = 2,560
  COLUMNS = 30
  ROWS = 17
  SCREEN_SIZE = COLUMNS * ROWS
  MAX_MENU_NAME_SIZE = 8
  RESERVED_BYTES_MENU_NAME_SIZE = MAX_MENU_NAME_SIZE + 1
  BYTES_PER_BUTTON_PTR = 2
  BUTTON_TYPE_OFFSET = 4
  
CON  '' SD Card File System
{{
  The touchscreen menu information for the robot remote will be contained on a SD card.
  There will be two master files. One file will have a list of pointers to
  the names of the various files contained in a second file. This second file
  will contain the names of the files. The pointers in the first file will make finding
  the names in the second file faster. If there is room in hub RAM this list of pointer
  can be copied into the RAM. The first long of the first master file will contain the
  number of menu files which have been created. The name of this first file will be
  "ptrList.mst". The name of the file containing names of the menu files will be "nameList.mst".
  The menu files will have the extention "mnu".

  Add an additional byte to the button data to indicate if the button is to launch a
  new menu or if it's to trigger an action.
  
}}
  ' buttonType enumeration
  #0, ACTION_BUTTON, MENU_BUTTON
  
  ' menu enumeration
  #1, MENU_START, MENU_SET_DATE, MENU_SET_YEAR, MENU_SET_MONTH, MENU_SET_DAY, {
    } MENU_SET_TIME, MENU_SET_HOUR, MENU_SET_MINUTE, MENU_SET_SECOND, MENU_ROBOT, {
    } MENU_ROOMBA, MENU_S2, MENU_MINI_HEX, MENU_ROVER, MENU_CHARGE, MENU_ACTIVE_CHARGE, {
    } MENU_SLEEP_CHARGE, MENU_MECANUM, MENU_MECANUM_HELP, MENU_ROBONI, {
    } MENU_TIMERS_ALARMS, MENU_OTHER, MENU_OTHER_PRD, MENU_TOUCH_XY, MENU_NUNCHUCK, {
    } MENU_KNOB_CONTROL, MENU_TV, MENU_SPRINKLER, MENU_SPRINKLER_ADJUST, {
    } MENU_SPRINKLER_HELP, MENU_LAST                                                                            

CON ' Menu Actions

  #0, NO_ACTION, SET_TIMER_ACTION, SET_ALARM_ACTION, LIGHT_SINGLE_ACTION, { 0-3
    } LIGHT_GROUP_ACTION, MAIN_LED_DUTY_ACTION, PERIMETER_LED_DUTY_ACTION, LED_BACK_ACTION, { 4-7
    } LED_FORWARD_ACTION, ONE_UP_MENU_ACTION, CHANNEL_UP_ACTION, CHANNEL_DOWN_ACTION, { 8-11
    } VOLUME_UP_ACTION, VOLUME_DOWN_ACTION, BOX_POWER_ACTION, VCR_POWER_ACTION, { 12-15  
    } TV_POWER_ACTION, SET_TARGET_TEMP_ACTION, SET_OVEN_TIME_ACTION, MENU_SPRINKLER_EDIT_ACTION, { 16-19 
    } MENU_SPRINKLER_VIEW_ACTION, SET_HOUR_ACTION, SET_MINUTE_ACTION, SET_SECOND_ACTION, { 20-23 
    } SET_YEAR_ACTION, SET_MONTH_ACTION, SET_DATE_ACTION, SET_DAY_OF_WEEK_ACTION, { 24-27 
    } LINE_ON_1_ACTION, LINE_ON_2_ACTION, LINE_ON_3_ACTION, LINE_ON_4_ACTION, { 28-31 
    } LINE_ON_5_ACTION, NUNCHUCK_OFF_ACTION, TOGGLE_SD_ACTION, INPUT_0_ACTION, { 32-35 
    } INPUT_1_ACTION, INPUT_2_ACTION, INPUT_3_ACTION, INPUT_4_ACTION, { 36-39 
    } INPUT_5_ACTION, INPUT_6_ACTION, INPUT_7_ACTION, INPUT_8_ACTION, { 40-43 
    } INPUT_9_ACTION, INPUT_A_ACTION, INPUT_B_ACTION, END_CHARGE_ACTION, { 44-47 
    } CANCEL_CHARGE_ACTION, LINE_STOP_ACTION, LAST_ACTION

CON ' SD Card Constants

    ' Actions for Exists routine
  SD_ACTION_NONE = 0   ' No action, return non-zero if file doesn't exist
  SD_ACTION_DELETE = 1 ' Return's 0 if file deleted, returns non-zero if error deleting it
  SD_ACTION_BOOT = 2   ' Boots the file
  SD_ACTION_CREATE = 3 ' Create a 1-line empty file ready for editing

PUB GetObjectName

  result := @objectName

PUB GetMasterName(localIndex)

  case localIndex
    0:
      result := @master0
    1:
      result := @master1

PUB GetMenuFileSuffix

  result := @menuFileSuffix
       
DAT

master0                 byte "ptrList.mst", 0
master1                 byte "nameList.mst", 0

menuFileSuffix          byte ".mnu", 0
  